/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <hamsandwich>

#define PLUGIN "Unicode Patch Support"
#define VERSION "0.1.3"
#define AUTHOR "PomanoB"

new g_cvar_all_talk
new g_max_players

new g_msgSayText

new g_playersTeam[33], g_playersAuthId[33][32]
new g_playersName[33][32], g_playersUserId[33]

new bool:g_playersConnected[33]
new g_playersAlive[33]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	RegisterHam(Ham_Spawn, "player", "fwdSpawn", 1)
	RegisterHam(Ham_Killed, "player", "fwdKilled")
	
	register_clcmd("say", "cmdSay")
	register_clcmd("say_team", "cmdSayTeam")
	
	g_cvar_all_talk = get_cvar_pointer("sv_alltalk")
	g_max_players = get_maxplayers()
	
	g_msgSayText = get_user_msgid("SayText")
	
	register_message(get_user_msgid("TeamInfo"), "msgTeamInfo")
}

public client_putinserver(id)
{
	g_playersConnected[id] = true
	get_user_authid(id, g_playersAuthId[id], 31)
	get_user_name(id, g_playersName[id], 31)
	g_playersUserId[id] = get_user_userid(id)
}

public client_infochanged(id)
{
	get_user_info(id, "name", g_playersName[id], 31)
}

public client_disconnect(id)
{
	g_playersConnected[id] = false
}

public fwdSpawn(id)
{
	if (is_user_alive(id))
		g_playersAlive[id] = 1
}
public fwdKilled(id, idattacker, shouldgib)
{
	g_playersAlive[id] = 0
}

public msgTeamInfo()
{
	new team[32], player
	get_msg_arg_string(2, team, 31)
	
	player = get_msg_arg_int(1)
	if (equal(team, "TERRORIST"))
		g_playersTeam[player] = 1
	else if (equal(team, "CT"))
		g_playersTeam[player] = 2
	else if (equal(team, "SPECTATOR"))
		g_playersTeam[player] = 3
	else
		g_playersTeam[player] = 0
}

public cmdSay(id)
{
	return sayHandle(id, false)
}

public cmdSayTeam(id)
{
	return sayHandle(id, true)
}

public sayHandle(id, bool:is_say_team)
{
	new message[256]
	new is_alive = g_playersAlive[id]
	new team = g_playersTeam[id]
	
	new msgFlag = 0
	
	read_argv(0, message, charsmax(message))
	
		
	read_args(message, charsmax(message))
	remove_quotes(message)
	
		
	
	if (is_say_team)
		msgFlag |= team
	else
	if (team == 3)
		msgFlag = 7
		
	if (!is_alive && (1 <= team <= 2))
		msgFlag |= 4
		
	if (!team)
	{
		if (is_say_team)
			msgFlag = 3
		else
			msgFlag = 4
	}
	
	static const messages[8][] = 
	{
		"#Cstrike_Chat_All",
		"#Cstrike_Chat_T",
		"#Cstrike_Chat_CT",
		"#Cstrike_Chat_Spec",
		"#Cstrike_Chat_AllDead",
		"#Cstrike_Chat_T_Dead",
		"#Cstrike_Chat_CT_Dead",
		"#Cstrike_Chat_AllSpec"
	}
	
	
	new curIsAlive
	new allTalk = get_pcvar_num(g_cvar_all_talk) != 0
	new i
	
	for (i = 1; i <= g_max_players; i++)
	{
		if (!g_playersConnected[i])
			continue
			
		curIsAlive = g_playersAlive[i]
		
		if (!allTalk && (is_alive != curIsAlive))
			continue
		if (is_say_team && team != g_playersTeam[i])
			continue
			
		message_begin(MSG_ONE, g_msgSayText, _, i)
		write_byte(id)
		write_string(messages[msgFlag])
		write_string("")
		write_string(message)
		message_end()
	}
	
	static const teamNames[4][] = {
		"",
		"TERRORIST",
		"CT",
		"SPECTATOR"
	}
	
	log_message("^"%s<%d><%s><%s>^" %s ^"%s^"%s", 
		g_playersName[id], 
		g_playersUserId[id],
		g_playersAuthId[id],
		teamNames[g_playersTeam[id]],
		(is_say_team ? "say_team" : "say"),
		message,
		(is_alive ? "" : " (dead)"))
		
	
	return PLUGIN_HANDLED
}

